/* X/lang - Calculator 0.1
 * -----------------------
 *
 * This program is a X/lang example
 */

handle     frame;
handle     entry;
handle[10] b;
handle     bp;

handle  bclean;
handle  badd;
handle  bmin;
handle  bmul;
handle  bdiv;
handle  bres;

string  number;
float   last;
uint    oper;

void calc_add (string n)
{
  number = lang_stradd (number, n);
  wnd_textentry_set_text (entry, number);
}

void calc_clean ()
{
  number = "";
}

void calc_quit ()
{
  io_write ("Exiting ...\n");
  sys_exit (0);
}

void bclean_clicked (handle btn)
{
  oper = 0;
  last = 0;
  number = "";
  wnd_textentry_set_text (entry, lang_itostr (0));
}

void bp_clicked (handle btn)
{
  calc_add (".");
}

void digit_clicked (handle btn)
{
  if (btn == b[0])
    calc_add ("0");
  if (btn == b[1])
    calc_add ("1");
  if (btn == b[2])
    calc_add ("2");
  if (btn == b[3])
    calc_add ("3");
  if (btn == b[4])
    calc_add ("4");
  if (btn == b[5])
    calc_add ("5");
  if (btn == b[6])
    calc_add ("6");
  if (btn == b[7])
    calc_add ("7");
  if (btn == b[8])
    calc_add ("8");
  if (btn == b[9])
    calc_add ("9");
}

void badd_clicked (handle btn)
{
  calc_oper ();
  oper = 1;
}

void bmin_clicked (handle btn)
{
  calc_oper ();
  oper = 2;
}

void bmul_clicked (handle btn)
{
  calc_oper ();
  oper = 3;
}

void bdiv_clicked (handle btn)
{
  calc_oper ();
  oper = 4;
}

void bres_clicked (handle btn)
{
  calc_oper ();
  oper = 10;
}

void calc_oper ()
{
  if (oper == 0)
    last = lang_strtof (number);

  if (oper == 1)
    last = last + lang_strtof (number);

  if (oper == 2)
    last = last - lang_strtof (number);

  if (oper == 3)
    last = last * lang_strtof (number);

  if (oper == 4)
    last = last / lang_strtof (number);

  calc_clean ();
  wnd_textentry_set_text (entry, lang_ftostr (last));
}

void main (string[] args)
{
  io_write ("X/lang - Calculator 0.1\n");

  /* Building the interface
   */

  last = 0;
  oper = 0;
  number = "";

  frame = wnd_window_new ("X/lang - Calculator 0.1", 100, 100, 270, 270);
  entry = wnd_textentry_new ("0", 20, 20, 230, 22, frame);

  b[7] = wnd_button_new ("7", 20, 70, 30, 30, frame);

  b[8] = wnd_button_new ("8", 60, 70, 30, 30, frame);
  b[9] = wnd_button_new ("9", 100, 70, 30, 30, frame);

  b[4] = wnd_button_new ("4", 20, 110, 30, 30, frame);
  b[5] = wnd_button_new ("5", 60, 110, 30, 30, frame);
  b[6] = wnd_button_new ("6", 100, 110, 30, 30, frame);

  b[1] = wnd_button_new ("1", 20, 150, 30, 30, frame);
  b[2] = wnd_button_new ("2", 60, 150, 30, 30, frame);
  b[3] = wnd_button_new ("3", 100, 150, 30, 30, frame);

  b[0] = wnd_button_new ("0", 60, 190, 30, 30, frame);

  bp = wnd_button_new (".", 100, 190, 30, 30, frame);

  bclean = wnd_button_new ("C", 210, 70, 30, 30, frame);

  badd = wnd_button_new ("+", 170, 70, 30, 30, frame);
  bmin = wnd_button_new ("-", 170, 110, 30, 30, frame);
  bmul = wnd_button_new ("*", 170, 150, 30, 30, frame);
  bdiv = wnd_button_new ("/", 170, 190, 30, 30, frame);
  bres = wnd_button_new ("=", 210, 190, 30, 30, frame);

  wnd_register (frame, "window::close", "calc_quit");


  wnd_register (b[9], "button::clicked", "digit_clicked");
  wnd_register (b[8], "button::clicked", "digit_clicked");
  wnd_register (b[7], "button::clicked", "digit_clicked");
  wnd_register (b[6], "button::clicked", "digit_clicked");
  wnd_register (b[5], "button::clicked", "digit_clicked");
  wnd_register (b[4], "button::clicked", "digit_clicked");
  wnd_register (b[3], "button::clicked", "digit_clicked");
  wnd_register (b[2], "button::clicked", "digit_clicked");
  wnd_register (b[1], "button::clicked", "digit_clicked");
  wnd_register (b[0], "button::clicked", "digit_clicked");

  wnd_register (bp, "button::clicked", "bp_clicked");

  wnd_register (bclean, "button::clicked", "bclean_clicked");

  wnd_register (badd, "button::clicked", "badd_clicked");
  wnd_register (bmin, "button::clicked", "bmin_clicked");
  wnd_register (bmul, "button::clicked", "bmul_clicked");
  wnd_register (bdiv, "button::clicked", "bdiv_clicked");

  wnd_register (bres, "button::clicked", "bres_clicked");

  /* Start the GUI
   */

  bclean_clicked (bclean);

  wnd_main ();
}





