/*
  File autogenerated by gengetopt version 2.2  
  generated with the following command:
  gengetopt 

  The developers of gengetopt consider the fixed text that goes in all
  gengetopt output files to be in the public domain:
  we make no copyright claims on it.
*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
/* Check for configure's getopt check result.  */
#ifndef HAVE_GETOPT_LONG
#include "getopt.h"
#else
#include <getopt.h>
#endif

#include "cmdline.h"

static void
print_version (void)
{
  printf ("%s %s\n", PACKAGE, VERSION);
}

static void
print_help (void)
{
  print_version ();
  printf ("Usage: %s [OPTIONS]...\n\
   -h         --help                Print help and exit\n\
   -V         --version             Print version and exit\n\
   -iSTRING   --input-file=STRING   input file (default std input)\n\
   -lSTRING   --lang=STRING         input language selection\n\
   -oSTRING   --lang-output=STRING  output language selection\n\
", PACKAGE);
}


static char *
gengetopt_strdup (char * s)
{
  char * n, * pn, * ps = s;
  while (*ps) ps++;
  n = (char *) malloc (1 + ps - s);
  if (n != NULL)
    {
      for (ps=s,pn=n; *ps; ps++,pn++)
        *pn = *ps;
      *pn = 0;
    }
  return n;
}


int
cmdline_parser (int argc, char * const *argv, struct gengetopt_args_info *args_info)
{
  int c;	/* Character of the parsed option.  */
  int missing_required_options = 0;	

  args_info->help_given = 0 ;
  args_info->version_given = 0 ;
  args_info->input_file_given = 0 ;
  args_info->lang_given = 0 ;
  args_info->lang_output_given = 0 ;
#define clear_args() { \
  args_info->input_file_arg = NULL; \
  args_info->lang_arg = NULL; \
  args_info->lang_output_arg = NULL; \
}

  clear_args();

  while (1)
    {
      int option_index = 0;
      static struct option long_options[] = {
        { "help",	0, NULL, 'h' },
        { "version",	0, NULL, 'V' },
        { "input-file",	1, NULL, 'i' },
        { "lang",	1, NULL, 'l' },
        { "lang-output",	1, NULL, 'o' },
        { NULL,	0, NULL, 0 }
      };

      c = getopt_long (argc, argv, "hVi:l:o:", long_options, &option_index);

      if (c == -1) break;	/* Exit from `while (1)' loop.  */

      switch (c)
        {
        case 'h':	/* Print help and exit.  */
          clear_args ();
          print_help ();
          exit (0);

        case 'V':	/* Print version and exit.  */
          clear_args ();
          print_version ();
          exit (0);

        case 'i':	/* input file (default std input).  */
          if (args_info->input_file_given)
            {
              fprintf (stderr, "%s: `--input-file' (`-i') option given more than once\n", PACKAGE);
              clear_args ();
              print_help ();
              exit (1);
            }
          args_info->input_file_given = 1;
          args_info->input_file_arg = gengetopt_strdup (optarg);
          break;

        case 'l':	/* input language selection.  */
          if (args_info->lang_given)
            {
              fprintf (stderr, "%s: `--lang' (`-l') option given more than once\n", PACKAGE);
              clear_args ();
              print_help ();
              exit (1);
            }
          args_info->lang_given = 1;
          args_info->lang_arg = gengetopt_strdup (optarg);
          break;

        case 'o':	/* output language selection.  */
          if (args_info->lang_output_given)
            {
              fprintf (stderr, "%s: `--lang-output' (`-o') option given more than once\n", PACKAGE);
              clear_args ();
              print_help ();
              exit (1);
            }
          args_info->lang_output_given = 1;
          args_info->lang_output_arg = gengetopt_strdup (optarg);
          break;

        case 0:	/* Long option with no short option */

        case '?':	/* Invalid option.  */
          /* `getopt_long' already printed an error message.  */
          exit (1);

        default:	/* bug: option not considered.  */
          fprintf (stderr, "%s: option unknown: %c\n", PACKAGE, c);
          abort ();
        } /* switch */
    } /* while */

  if (! args_info->input_file_given)
    {
      fprintf (stderr, "%s: `--input-file' (`-i') option required!\n", PACKAGE);
      missing_required_options = 1;
    }

  if (! args_info->lang_given)
    {
      fprintf (stderr, "%s: `--lang' (`-l') option required!\n", PACKAGE);
      missing_required_options = 1;
    }

  if ( missing_required_options )
    exit (1);


  return 0;
}
