/* X/lang - the eXtensible Language
 * Copyright (C) 2001 Patrick Deschenes
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

/* These files are distributed at http://xlang.sourceforge.net
 */

#include <xlclass.h>
#include <xlfield.h>

XLClass*
xl_class_new (XString* p_name)
{
  XLClass *self;
  
  self = x_new (XLClass);
  x_object_init_object (X_OBJECT (self), xl_class_destroy);

  self->name = x_addref (XString, p_name);
  self->parent_class = NULL;
  self->list_fields = x_list_new ();

  return self;
}

xvoid
xl_class_destroy (XObject* self)
{
}

xvoid
xl_class_init_data (XLClass* self, XLData* p_data)
{
}

xu32
xl_class_get_size (XLClass* self)
{
  return 0;
}

xvoid
xl_class_add_field (XLClass* self, XLField* p_field)
{
  p_field->index = self->size;
  self->size += xl_type_get_size (p_field->type);
  x_list_add (self->list_fields, X_OBJECT (p_field));
}

XLField*
xl_class_get_field (XLClass* self, XString* p_name)
{
  XLField*	l_field;
  xu32		i, l_size;
	
  l_size = x_list_get_size (self->list_fields);
  
  for (i = 0; i < l_size; i++)
    {
      l_field = XL_FIELD (x_list_get (self->list_fields, i));
      if (x_string_cmp (p_name, l_field->name) == 0)
	return l_field;
       
      x_unref (l_field);
    }
  
  return NULL;
}
