/* X/lang - the eXtensible Language
 * Copyright (C) 2001 Patrick Deschenes
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

/* These files are distributed at http://xlang.sourceforge.net
 */

#include <xllangc.h>
#include <xllang.h>
#include <xlmain.h>
#include <langc_yacc.h>

XLExpr* g_xl_langc_expr;

XLLangC*
xl_lang_c_new ()
{
  XLLangC*	self;
  
  self = x_new (XLLangC);
  x_object_init_object (X_OBJECT (self), xl_lang_c_destroy);

  self->parent.load = xl_lang_c_load;
  self->idx = 0;
  self->data = NULL;
  self->fileid = NULL;
  self->line = 1;
  self->oper = FALSE;
  
  return self;
}

xvoid
xl_lang_c_destroy (XObject* self)
{
  x_destroy (self);
}

XLExpr*
xl_lang_c_load (XLLang* self, XString* p_filename)
{
  XLExpr*	l_expr;
  XLExpr*	l_subexpr;
  
  g_xl_langc_expr = xl_expr_new ();
  xl_expr_set_block (g_xl_langc_expr);

  /* Parsing C-like language
   */

  printf ("Parsing %s ...\n", x_string_get_str (p_filename));

  freopen (x_string_get_str (p_filename), "r", stdin);
  c_parse ();
  
  return g_xl_langc_expr;
}

void
c_error (char *s)
{
  fprintf (stderr, "X/lang ERROR\n");
}

int
c_wrap ()
{
  return 1;
}
