/* X/lang - the eXtensible Language
 * Copyright (C) 2001 Patrick Deschenes
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

/* These files are distributed at http://xlang.sourceforge.net
 */

#ifndef __XL_LANG_C_H_
#define __XL_LANG_C_H_

#include <xdefs.h>
#include <xobject.h>
#include <xstring.h>
#include <xlexpr.h>
#include <xllang.h>

#define XL_LANG_C(obj) ((XLLangC*) obj)

typedef struct _XLLangC XLLangC;
struct _XLLangC
{
  XLLang  parent;
  
  FILE*	  fileid;
  xstr	  data;
  xu32	  idx;
  xu32    line;
  xbool	  oper;
};

XLLangC*
xl_lang_c_new ();

xvoid
xl_lang_c_destroy (XObject* self);

xs8
xl_lang_c_getc (XLLangC* self);

xvoid
xl_lang_c_ungetc (XLLangC* self, xs8 p_char);

XLExpr*
xl_lang_c_load (XLLang* self, XString* p_filename);

XLExpr*
xl_lang_c_parse (XLLangC* self);

xvoid
xl_lang_c_parse_comments (XLLangC* self);

XString*
xl_lang_c_parse_name (XLLangC* self);

XLExpr*
xl_lang_c_parse_type (XLLangC* self);

XLExpr*
xl_lang_c_parse_data (XLLangC* self);

XLExpr*
xl_lang_c_parse_fnct (XLLangC* self);

XLExpr*
xl_lang_c_parse_identifier (XLLangC* self);

#endif
